Index: /boa/src/main/java/geniusweb/boa/biddingstrategy/ExtendedUtilSpace.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/biddingstrategy/ExtendedUtilSpace.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/biddingstrategy/ExtendedUtilSpace.java	(revision 20)
@@ -0,0 +1,103 @@
+package geniusweb.boa.biddingstrategy;
+
+import java.math.BigDecimal;
+import java.math.BigInteger;
+import java.util.Collections;
+import java.util.LinkedList;
+
+import geniusweb.bidspace.BidsWithUtility;
+import geniusweb.bidspace.Interval;
+import geniusweb.bidspace.IssueInfo;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.Value;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import tudelft.utilities.immutablelist.ImmutableList;
+
+/**
+ * Inner class for TimeDependentParty, made public for testing purposes. This
+ * class may change in the future, use at your own risk. Copy of
+ * geniusweb.exampleparties.timedependentparty
+ *
+ */
+public class ExtendedUtilSpace {
+	private LinearAdditive utilspace;
+	private BigDecimal tolerance; // utility tolerance for a bid.
+	private BidsWithUtility bidutils;
+	// min and max achievable utility
+	private BigDecimal minUtil;
+	private BigDecimal maxUtil;
+
+	public ExtendedUtilSpace(LinearAdditive space) {
+		this.utilspace = space;
+		bidutils = new BidsWithUtility(utilspace);
+		computeMinMax();
+		this.tolerance = computeTolerance();
+
+	}
+
+	/**
+	 * Computes the fields minutil and maxUtil.
+	 * <p>
+	 * TODO this is simplistic, very expensive method and may cause us to run
+	 * out of time on large domains.
+	 * <p>
+	 * Assumes that utilspace and bidutils have been set properly.
+	 */
+	private void computeMinMax() {
+		Interval range = bidutils.getRange();
+		this.minUtil = range.getMin();
+		this.maxUtil = range.getMax();
+
+		Bid rvbid = utilspace.getReservationBid();
+		if (rvbid != null) {
+			BigDecimal rv = utilspace.getUtility(rvbid);
+			if (rv.compareTo(minUtil) > 0)
+				minUtil = rv;
+		}
+	}
+
+	/**
+	 * Tolerance is the Interval we need when searching bids. When we are close
+	 * to the maximum utility, this value has to be the distance between the
+	 * best and one-but-best utility.
+	 * 
+	 * @return the minimum tolerance required, which is the minimum difference
+	 *         between the weighted utility of the best and one-but-best issue
+	 *         value.
+	 */
+	protected BigDecimal computeTolerance() {
+		BigDecimal tolerance = BigDecimal.ONE;
+		for (IssueInfo iss : bidutils.getInfo()) {
+			if (iss.getValues().size().compareTo(BigInteger.ONE) > 0) {
+				// we have at least 2 values.
+				LinkedList<BigDecimal> values = new LinkedList<BigDecimal>();
+				for (Value val : iss.getValues()) {
+					values.add(iss.getWeightedUtil(val));
+				}
+				Collections.sort(values);
+				Collections.reverse(values);
+				tolerance = tolerance
+						.min(values.get(0).subtract(values.get(1)));
+			}
+		}
+		return tolerance;
+	}
+
+	public BigDecimal getMin() {
+		return minUtil;
+	}
+
+	public BigDecimal getMax() {
+		return maxUtil;
+	}
+
+	/**
+	 * @param utilityGoal
+	 * @return bids with utility inside [utilitygoal-tolerance, utilitygoal]
+	 */
+	public ImmutableList<Bid> getBids(BigDecimal utilityGoal) {
+		return bidutils.getBids(
+				new Interval(utilityGoal.subtract(tolerance), utilityGoal));
+	}
+
+}
Index: /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java	(revision 20)
+++ /boa/src/main/java/geniusweb/boa/biddingstrategy/TimeDependentBiddingStrategy.java	(revision 20)
@@ -0,0 +1,251 @@
+package geniusweb.boa.biddingstrategy;
+
+import java.math.BigDecimal;
+import java.util.HashMap;
+import java.util.List;
+import java.util.concurrent.ThreadLocalRandom;
+import java.util.logging.Level;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.boa.BoaState;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import tudelft.utilities.immutablelist.ImmutableList;
+
+/**
+ * This is an abstract class used to implement a TimeDependentAgent Strategy
+ * adapted from S. Shaheen Fatima Michael Wooldridge Nicholas R. Jennings
+ * Optimal Negotiation Strategies for Agents with Incomplete Information
+ * http://eprints.ecs.soton.ac.uk/6151/1/atal01.pdf
+ * <p>
+ * Required: the profile is {@link LinearAdditive}. Does not currently handle
+ * profile changes.
+ * <p>
+ * As basis, the original Genius'
+ * negotiator.boaframework.offeringstrategy.other.GeniusTimeDependent_Offering
+ * was used. However that seems to ignore the reservation value. This was fixed
+ * here.
+ * <p>
+ * The default strategy was extended to enable the usage of opponent models.
+ * <p>
+ * The time-dependent utility target function is f(t) = k + (1.0 - k) *
+ * Math.pow((t - startTime) / (1.0 - startTime), 1.0 / e). The utility target is
+ * then set at min+(max-min)*f(t) where the default values for min = either the
+ * utility of the reservation bid or the absolute minimum utility of the
+ * profile, and default for max the maximum attainable utility.
+ * <p>
+ * 
+ * Parameters:
+ * <ul>
+ * <li>e: see {@link #getE(BoaState)}
+ * <li>k: see {@link #getK(BoaState)}
+ * <li>min: see {@link #getMin(BoaState)}.
+ * <li>max: see {@link #getMax(BoaState)}
+ * </ul>
+ */
+public class TimeDependentBiddingStrategy implements BiddingStrategy {
+	// bidSpace=null means we're not yet initialized.
+	private ExtendedUtilSpace bidSpace = null;
+	private Double e, k, min, max; // min, max attainable utility
+	private PartyId me;
+
+	@Override
+	public Action getAction(BoaState state) {
+		if (bidSpace == null) {
+			init(state);
+		}
+
+		double utilityGoal = p(
+				state.getProgress().get(System.currentTimeMillis()));
+
+		// if there is no opponent model available
+		ImmutableList<Bid> bidOptions = bidSpace
+				.getBids((BigDecimal.valueOf(utilityGoal)));
+
+		if (bidOptions.size().intValue() == 0) {
+			// should not happen, emergency exit
+			state.getReporter().log(Level.WARNING,
+					"No viable bids found around current utility target");
+			Bid lastBid = getLastBid(state.getActionHistory());
+			if (lastBid == null)
+				return new EndNegotiation(me);
+			return new Accept(me, lastBid);
+		}
+		Bid pickedBid = bidOptions.get(ThreadLocalRandom.current()
+				.nextInt(bidOptions.size().intValue()));
+		return new Offer(me, pickedBid);
+
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the parameter e for the time depemdency function
+	 *         {@link #f(double)}. The parameter is 1 by default, or the value
+	 *         for the "e" parameter in the {@link Settings} if available.
+	 */
+	protected Double getE(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		Double e = 1d;
+		if (params.containsKey("e")) {
+			e = (Double) params.get("e");
+			if (e < 0 || e > 1)
+				throw new IllegalArgumentException(
+						"e must be in [0,1] but got " + this.e);
+		}
+		return e;
+	}
+
+	/**
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the parameter k for the time depemdency function
+	 *         {@link #f(double)}. The parameter is 0 by default, or the value
+	 *         for the "k" parameter in the {@link Settings} if available.
+	 */
+	protected Double getK(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		Double k = 0d; // default
+		if (params.containsKey("k")) {
+			k = (Double) params.get("k");
+			if (k < 0 || k > 1)
+				throw new IllegalArgumentException(
+						"k must be in [0,1] but got " + this.e);
+		}
+		return k;
+	}
+
+	/**
+	 * Assumes {@link #bidSpace} has been initialized.
+	 * <p>
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the min value for {@link #p(double)}. We use the "min" parameter
+	 *         in the {@link Settings} if available. If not available, the
+	 *         parameter is computed as the utility of the reservation bid. If
+	 *         there is no reservation bid, we use the minimum utility of the
+	 *         available profile.
+	 */
+	protected Double getMin(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		if (params.containsKey("min")) {
+			return Math.max(0f, Math.min(1f, (Double) params.get("min")));
+		}
+		LinearAdditive profile = (LinearAdditive) state.getProfile();
+		if (profile.getReservationBid() != null) {
+			return profile.getUtility(profile.getReservationBid())
+					.doubleValue();
+		}
+
+		return bidSpace.getMin().doubleValue();
+	}
+
+	/**
+	 * Assumes {@link #bidSpace} has been initialized.
+	 * <p>
+	 * Overrideable for hard configuring this component.
+	 * 
+	 * @param state the {@link BoaState}
+	 * @return the max value for {@link #p(double)}. We use the "max" parameter
+	 *         in the {@link Settings} if available. If not available, we use
+	 *         the maximum utility of the available profile.
+	 */
+	protected Double getMax(BoaState state) {
+		HashMap<String, Object> params = state.getSettings().getParameters();
+		if (params.containsKey("max")) {
+			return Math.max(0f, Math.min(1f, (Double) params.get("max")));
+		}
+		return bidSpace.getMax().doubleValue();
+
+	}
+
+	/**
+	 * @return the most recent bid that was offered, or null if no offer has
+	 *         been done yet.
+	 */
+	private Bid getLastBid(List<Action> history) {
+		for (int n = history.size() - 1; n >= 0; n--) {
+			Action action = history.get(n);
+			if (action instanceof Offer) {
+				return ((Offer) action).getBid();
+			}
+		}
+		return null;
+	}
+
+	/**
+	 * initializes bidSpace
+	 * 
+	 * @param state
+	 */
+	private void init(BoaState state) {
+		this.me = state.getSettings().getID();
+		Profile prof = state.getProfile();
+		if (!(prof instanceof LinearAdditive))
+			throw new IllegalArgumentException(
+					"Requires a LinearAdditive space but got " + prof);
+		LinearAdditive profile = (LinearAdditive) prof;
+
+		this.bidSpace = getBidSpace(profile);
+		this.e = getE(state);
+		this.k = getK(state);
+		this.min = getMin(state);
+		this.max = getMax(state);
+
+		state.getReporter().log(Level.INFO,
+				"BOA biddingstrategy min util = " + this.min);
+	}
+
+	/**
+	 * Makes sure the target utility with in the acceptable range according to
+	 * the domain
+	 * 
+	 * @param t the normalized current time in the negotiation, where t=9 at
+	 *          start of negotiation and t=1 at end of negotiation.
+	 * @return double
+	 */
+	private double p(double t) {
+		return this.min + (this.max - this.min) * (1.0 - f(t));
+	}
+
+	/**
+	 * From the paper:
+	 * 
+	 * A wide range of time dependent functions can be defined by varying the
+	 * way in which f(t) is computed. However, functions must ensure that 0 <=
+	 * f(t) <= 1, f(0) = k, and f(1) = 1.
+	 * 
+	 * That is, the offer will always be between the value range, at the
+	 * beginning it will give the initial constant and when the deadline is
+	 * reached, it will offer the reservation value.
+	 * 
+	 * @param t the normalized current time in the negotiation, where t=9 at
+	 *          start of negotiation and t=1 at end of negotiation.
+	 * @return
+	 */
+	private double f(double t) {
+		double ft = k + (1.0 - k) * Math.pow(t, 1.0 / e);
+		return ft;
+	}
+
+	/**
+	 * Factory method to get the {@link ExtendedUtilSpace} helper class.
+	 * Overridable eg for tests
+	 * 
+	 * @param profile
+	 * 
+	 * @return {@link ExtendedUtilSpace}
+	 */
+	protected ExtendedUtilSpace getBidSpace(LinearAdditive profile) {
+		return new ExtendedUtilSpace(profile);
+	}
+}
Index: /boa/src/test/java/geniusweb/boa/BoaPartyTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/BoaPartyTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/BoaPartyTest.java	(revision 20)
@@ -0,0 +1,235 @@
+package geniusweb.boa;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.eq;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.verify;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.util.LinkedList;
+import java.util.List;
+
+import org.junit.Test;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.boa.acceptancestrategy.AcceptanceStrategy;
+import geniusweb.boa.biddingstrategy.BiddingStrategy;
+import geniusweb.connection.ConnectionEnd;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Domain;
+import geniusweb.opponentmodel.OpponentModel;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.progress.Progress;
+import geniusweb.references.Parameters;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+
+public class BoaPartyTest {
+	private static final Bid otherBid = new Bid("issue",
+			new DiscreteValue("value2"));
+	private static final PartyId OTHER = new PartyId("other");
+	private static final Bid BID1 = new Bid("issue",
+			new DiscreteValue("value"));
+	private static final PartyId ME = new PartyId("me");
+	private TestConnection connection = new TestConnection();
+	private static final String PROFILE = "src/test/resources/testprofile.json";
+
+	protected static final Offer biddingstratOffer = new Offer(ME, BID1);
+	private static final Offer othersOffer = new Offer(OTHER, otherBid);
+	private static final Accept accept = new Accept(ME, BID1);
+	private static final EndNegotiation endnego = new EndNegotiation(OTHER);
+
+	@Test(expected = RuntimeException.class)
+	public void smokeTestMissingInit() {
+		BoaParty boa = new BoaParty();
+		boa.connect(connection);
+		boa.notifyChange(mock(ActionDone.class));
+	}
+
+	@Test
+	public void settingsTest() throws URISyntaxException {
+		BoaState state = mock(BoaState.class);
+		BoaParty boa = new BoaParty() {
+			@Override
+			protected BoaState initialState() {
+				return state;
+			}
+		};
+		boa.connect(connection);
+		PartyId id = new PartyId("testparty");
+		ProfileRef profile = new ProfileRef(new URI("file:" + PROFILE));
+		ProtocolRef protocol = new ProtocolRef("SAOP");
+		Progress progress = mock(Progress.class);
+		Parameters parameters = new Parameters();
+		parameters.put("om", omMock.class.getCanonicalName());
+		parameters.put("bs", bsMock.class.getCanonicalName());
+		parameters.put("as", asMock.class.getCanonicalName());
+		Settings info = new Settings(id, profile, protocol, progress,
+				parameters);
+		boa.notifyChange(info);
+		// weird bug in Mockito? Work around with a weird cast...
+		verify(state).with((Settings) eq(info), any(bsMock.class),
+				any(asMock.class), (Class) eq(omMock.class));
+	}
+
+	@Test
+	public void youStartTestE2E() throws URISyntaxException {
+		BoaParty boa = getInitializedBoa();
+
+		boa.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		System.out.println("party did action:" + connection.getActions());
+		// this should come out of bidding strat as there is no acceptable offer
+		assertEquals(biddingstratOffer, connection.getActions().get(0));
+	}
+
+	@Test
+	public void otherOfferstTestE2E() throws URISyntaxException {
+		BoaParty boa = getInitializedBoa();
+
+		boa.notifyChange(new ActionDone(othersOffer));
+
+		boa.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		System.out.println("party did action:" + connection.getActions());
+		// this should come out of bidding strat as there is no acceptable offer
+		// Because asMock always accepts, this should accept.
+		assertTrue(connection.getActions().get(0) instanceof Accept);
+	}
+
+	@Test
+	public void getLastBidTest() throws URISyntaxException {
+		BoaParty boa = getInitializedBoa();
+
+		// just a potpourri of actions.
+		boa.notifyChange(new ActionDone(biddingstratOffer));
+		boa.notifyChange(new ActionDone(endnego));
+		boa.notifyChange(new ActionDone(othersOffer));
+		boa.notifyChange(new ActionDone(accept));
+		assertEquals(otherBid, boa.getLastBid());
+
+	}
+
+	private BoaParty getInitializedBoa() throws URISyntaxException {
+		BoaParty boa = new BoaParty();
+		boa.connect(connection);
+		PartyId id = new PartyId("testparty");
+		ProfileRef profile = new ProfileRef(new URI("file:" + PROFILE));
+		ProtocolRef protocol = new ProtocolRef("SAOP");
+		Progress progress = mock(Progress.class);
+		Parameters parameters = new Parameters();
+		parameters.put("om", omMock.class.getCanonicalName());
+		parameters.put("bs", bsMock.class.getCanonicalName());
+		parameters.put("as", asMock.class.getCanonicalName());
+		Settings info = new Settings(id, profile, protocol, progress,
+				parameters);
+		boa.notifyChange(info);
+		return boa;
+	}
+
+}
+
+class asMock implements AcceptanceStrategy {
+
+	@Override
+	public Boolean isAcceptable(Bid bid, BoaState negoState) {
+		return true;
+	}
+
+}
+
+class bsMock implements BiddingStrategy {
+
+	@Override
+	public Action getAction(BoaState state) {
+		return BoaPartyTest.biddingstratOffer;
+	}
+
+}
+
+class omMock implements OpponentModel {
+
+	@Override
+	public String getName() {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
+	@Override
+	public Domain getDomain() {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
+	@Override
+	public Bid getReservationBid() {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
+	@Override
+	public OpponentModel with(Domain domain, Bid resBid) {
+		return this;
+	}
+
+	@Override
+	public OpponentModel with(Action action, Progress progress) {
+		return this;
+	}
+
+}
+
+/**
+ * A "real" connection object, because the party is going to subscribe etc, and
+ * without a real connection we would have to do a lot of mocks that would make
+ * the test very hard to read.
+ *
+ */
+class TestConnection extends DefaultListenable<Inform>
+		implements ConnectionEnd<Inform, Action> {
+	private List<Action> actions = new LinkedList<>();
+
+	@Override
+	public void send(Action action) throws IOException {
+		actions.add(action);
+	}
+
+	@Override
+	public Reference getReference() {
+		return null;
+	}
+
+	@Override
+	public URI getRemoteURI() {
+		return null;
+	}
+
+	@Override
+	public void close() {
+
+	}
+
+	@Override
+	public Error getError() {
+		return null;
+	}
+
+	public List<Action> getActions() {
+		return actions;
+	}
+
+}
Index: /boa/src/test/java/geniusweb/boa/BoaStateTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/BoaStateTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/BoaStateTest.java	(revision 20)
@@ -0,0 +1,5 @@
+package geniusweb.boa;
+
+public class BoaStateTest {
+
+}
Index: /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/acceptancestrategy/TimeDepAccStratTest.java	(revision 20)
@@ -0,0 +1,131 @@
+package geniusweb.boa.acceptancestrategy;
+
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Matchers.eq;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.when;
+
+import java.math.BigDecimal;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.bidspace.BidsWithUtility;
+import geniusweb.bidspace.Interval;
+import geniusweb.boa.BoaState;
+import geniusweb.issuevalue.Bid;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.Profile;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.progress.Progress;
+import geniusweb.progress.ProgressRounds;
+
+public class TimeDepAccStratTest {
+	private static final Bid resbid = mock(Bid.class);
+	private final Progress progress = mock(ProgressRounds.class);
+	private final BidsWithUtility testbidspace = mock(BidsWithUtility.class);
+	private final BoaState state = mock(BoaState.class);
+	private final Bid bid1 = mock(Bid.class);
+	private final Settings settings = mock(Settings.class);
+	private final LinearAdditive linearprofile = mock(LinearAdditive.class);
+
+	@Before
+	public void before() {
+		when(state.getSettings()).thenReturn(settings);
+		when(state.getProfile()).thenReturn(linearprofile);
+		when(state.getProgress()).thenReturn(progress);
+
+	}
+
+	@Test
+	public void testRoundsProgressAtStart() {
+		when(testbidspace.getRange())
+				.thenReturn(new Interval(BigDecimal.ZERO, BigDecimal.ONE));
+
+		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			protected BidsWithUtility getBidspace(Profile profile) {
+				return testbidspace;
+			}
+		};
+		// we use default e=1, k=0 which means p(0)=1
+
+		when(progress.get(any())).thenReturn((Double) 0.0d);
+
+		when(linearprofile.getUtility(eq(bid1)))
+				.thenReturn(BigDecimal.valueOf(0.4));
+
+		assertFalse(ac.isAcceptable(bid1, state));
+	}
+
+	@Test
+	public void testRoundsProgressAtStart1() {
+		when(testbidspace.getRange()).thenReturn(
+				new Interval(BigDecimal.ZERO, new BigDecimal("0.4")));
+		// the max util in this space is 0.4
+
+		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			protected BidsWithUtility getBidspace(Profile profile) {
+				return testbidspace;
+			}
+		};
+		// we use default e=1, k=0 which means p(0)=1
+
+		when(progress.get(any())).thenReturn((Double) 0.0d);
+
+		when(linearprofile.getUtility(eq(bid1)))
+				.thenReturn(new BigDecimal("0.4")); // now =max util
+
+		assertTrue(ac.isAcceptable(bid1, state));
+	}
+
+	@Test
+	public void testRoundsProgressAtEnd() {
+		when(testbidspace.getRange())
+				.thenReturn(new Interval(BigDecimal.ZERO, BigDecimal.ONE));
+
+		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			protected BidsWithUtility getBidspace(Profile profile) {
+				return testbidspace;
+			}
+		};
+		// we use default e=1, k=0 which means p(1)=0
+
+		when(progress.get(any())).thenReturn((Double) 1.0d);
+
+		when(linearprofile.getUtility(eq(bid1)))
+				.thenReturn(BigDecimal.valueOf(0.4));
+
+		assertTrue(ac.isAcceptable(bid1, state));
+	}
+
+	@Test
+	public void testRoundsProgressResValueIsUsed() {
+		// resbid should raise the minimum at the end.
+		// we check that at the end a bid with lower util than resbid is
+		// not accepted.
+		when(testbidspace.getRange())
+				.thenReturn(new Interval(BigDecimal.ZERO, BigDecimal.ONE));
+
+		TimeDependentAcceptanceStrategy ac = new TimeDependentAcceptanceStrategy() {
+			protected BidsWithUtility getBidspace(Profile profile) {
+				return testbidspace;
+			}
+		};
+		// we use default e=1, k=0 which means p(1)=resValue.
+
+		when(progress.get(any())).thenReturn((Double) 1.0d);
+
+		when(linearprofile.getUtility(eq(bid1)))
+				.thenReturn(BigDecimal.valueOf(0.4));
+
+		when(linearprofile.getReservationBid()).thenReturn(resbid);
+		when(linearprofile.getUtility(eq(resbid)))
+				.thenReturn(new BigDecimal("0.5"));
+
+		// bid1 has util 0.4 which is below res value.
+		assertFalse(ac.isAcceptable(bid1, state));
+	}
+
+}
Index: /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java
===================================================================
--- /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java	(revision 20)
+++ /boa/src/test/java/geniusweb/boa/biddingstrategy/TimeDepBidStratTest.java	(revision 20)
@@ -0,0 +1,155 @@
+package geniusweb.boa.biddingstrategy;
+
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
+import java.math.BigDecimal;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.Offer;
+import geniusweb.boa.BoaState;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.party.inform.Settings;
+import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.progress.Progress;
+import tudelft.utilities.immutablelist.FixedList;
+import tudelft.utilities.immutablelist.ImmutableList;
+import tudelft.utilities.logging.ReportToLogger;
+
+public class TimeDepBidStratTest {
+
+	// private static final String PROFILE =
+	// "src/test/resources/testprofile.json";
+	// private ProfileRef profileref;
+	private LinearAdditive profile = mock(LinearAdditive.class);
+	private TimeDependentBiddingStrategy biddingstrat;
+	private ExtendedUtilSpace extUtilSpace;
+	private Settings settings = mock(Settings.class);
+	private BoaState state = mock(BoaState.class);
+
+	private Bid bid1 = new Bid("iss1", new DiscreteValue("val1"));
+	private Bid resBid = new Bid("iss1", new DiscreteValue("val2"));
+	ImmutableList<Bid> alternatives = new FixedList<Bid>(Arrays.asList(bid1));
+
+	@Before
+	public void before() throws URISyntaxException {
+		when(state.getReporter()).thenReturn(new ReportToLogger("test"));
+
+		biddingstrat = new TimeDependentBiddingStrategy() {
+			protected ExtendedUtilSpace getBidSpace(LinearAdditive profile) {
+				return extUtilSpace;
+			}
+
+		};
+		// profileref = new ProfileRef(PROFILE);
+
+		extUtilSpace = mock(ExtendedUtilSpace.class);
+		when(extUtilSpace.getMin()).thenReturn(BigDecimal.ZERO);
+		when(extUtilSpace.getMax()).thenReturn(BigDecimal.ONE);
+
+	}
+
+	@Test
+	public void smoke() {
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void getActionTestNoProfile() {
+		when(state.getSettings()).thenReturn(settings);
+
+		biddingstrat.getAction(state);
+	}
+
+	@Test
+	public void getActionAtStart() {
+
+		when(state.getProfile()).thenReturn(profile);
+		when(state.getSettings()).thenReturn(settings);
+
+		Progress progress = mock(Progress.class);
+		when(progress.get(any())).thenReturn(0d);
+		// progress = right at start => utilitygoal 1.0
+
+		when(state.getProgress()).thenReturn(progress);
+		when(extUtilSpace.getBids(any())).thenReturn(alternatives);
+
+		Action action = biddingstrat.getAction(state);
+
+		// check that the recommender chose a bid in of utility 1.0
+		verify(extUtilSpace).getBids(BigDecimal.valueOf(1.0));
+		assertTrue(action instanceof Offer);
+	}
+
+	@Test
+	public void getActionAtHalfway() {
+
+		when(state.getProfile()).thenReturn(profile);
+		when(state.getSettings()).thenReturn(settings);
+
+		Progress progress = mock(Progress.class);
+		when(progress.get(any())).thenReturn(0.5d);
+		// progress = halfway => utilitygoal= 0.5
+
+		when(state.getProgress()).thenReturn(progress);
+		when(extUtilSpace.getBids(any())).thenReturn(alternatives);
+
+		Action action = biddingstrat.getAction(state);
+
+		// check that the recommender chose a bid in of utility 1.0
+		verify(extUtilSpace).getBids(BigDecimal.valueOf(0.5));
+		assertTrue(action instanceof Offer);
+	}
+
+	@Test
+	public void getActionAtEnd() {
+
+		when(state.getProfile()).thenReturn(profile);
+		when(state.getSettings()).thenReturn(settings);
+
+		Progress progress = mock(Progress.class);
+		when(progress.get(any())).thenReturn(1d);
+		// progress = end => utilitygoal= 0
+
+		when(state.getProgress()).thenReturn(progress);
+		when(extUtilSpace.getBids(any())).thenReturn(alternatives);
+
+		Action action = biddingstrat.getAction(state);
+
+		// check that the recommender chose a bid in of utility 1.0
+		verify(extUtilSpace).getBids(BigDecimal.valueOf(0.0));
+		assertTrue(action instanceof Offer);
+	}
+
+	@Test
+	public void getActionAtEndWithReservation() {
+		// if there is reservation bid, it should be considered min
+		when(profile.getReservationBid()).thenReturn(resBid);
+		when(profile.getUtility(resBid)).thenReturn(new BigDecimal("0.5"));
+
+		when(state.getProfile()).thenReturn(profile);
+		when(state.getSettings()).thenReturn(settings);
+
+		Progress progress = mock(Progress.class);
+		when(progress.get(any())).thenReturn(1d);
+		// progress = end => utilitygoal= resvalue=0.6
+
+		when(state.getProgress()).thenReturn(progress);
+		when(extUtilSpace.getBids(any())).thenReturn(alternatives);
+
+		Action action = biddingstrat.getAction(state);
+
+		// check that the recommender chose a bid in of utility 0.5
+		verify(extUtilSpace).getBids(BigDecimal.valueOf(0.5));
+		assertTrue(action instanceof Offer);
+	}
+
+}
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 20)
+++ /collectparties.sh	(revision 20)
@@ -0,0 +1,27 @@
+#!/bin/bash
+
+# this script collects all parties that are standard parties
+# on the partiesserver, and renames the jar-with-dependencies
+# The collected parties are placed in a new directory "collectedparties".
+
+rm -rf collectedparties
+mkdir collectedparties
+VERSION=1.4.4
+
+cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/boulware/target/boulware-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/comparebids/target/comparebids-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/conceder/target/conceder-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/hardliner/target/hardliner-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/linear/target/linear-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/randomparty/target/randomparty-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/randompartypy/target/randompyparty-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/simpleshaop/target/simpleshaop-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/timedependentparty/target/timedependentparty-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "exampleparties/anac2019/winkyagent/target/winkyagent-${VERSION}-jar-with-dependencies.jar" collectedparties
+cp "boa/target/boa-${VERSION}-jar-with-dependencies.jar" collectedparties
+
+cd collectedparties
+ for filename in ./*; do mv "./$filename" "./$(echo "$filename" | sed -e 's/-jar-with-dependencies//g')";  done
+
+
